/*
 * This file is subject to the MiscKit license, see http://www.misckit.org/
 * and search around for details. The bottom line is: you may do what you please
 * with this code, but you're on your own if you run into trouble...
 * Copyright (C) 1999,2000,2001 dmorin,anjo@mac.com
 * Portions of this code derived from the FlatFileAdaptor (C) Apple Computer
 */

#import <EOAccess/EOAccess.h>
#import <mysql.h>

@class MySQLContext;

@interface MySQLChannel : EOAdaptorChannel
{
    MYSQL *mysql;
    MYSQL_RES *result;
    NSArray* _attributes;
    NSMutableArray *_selectedColumns;
    BOOL useMySQLStoreResult;
    //ak: should be     my_ulonglong _rowsProcessedCount;
    unsigned long _rowsProcessedCount;
    unsigned int _fetchLimit;
    struct
    {
        unsigned isOpen:1;
        unsigned isFetchInProgress:1;
        unsigned _RESERVED:30;
    } _flags;
    BOOL debugEnabled;
}

- initWithMySQLContext:(MySQLContext *)context;
- (void)dealloc;
- (void)openChannel;
- (void)closeChannel;
- (BOOL)isOpen;

@end

@interface MySQLChannel(Private)

- (unsigned int)fetchLimit;
- (void)setFetchLimit:(unsigned int)newFetchLimit;

@end

