/*
 * This file is subject to the MiscKit license, see http://www.misckit.org/
 * and search around for details. The bottom line is: you may do what you please
 * with this code, but you're on your own if you run into trouble...
 * Copyright (C) 1999,2000,2001 dmorin,anjo@mac.com
 * Portions of this code derived from the FlatFileAdaptor (C) Apple Computer
 */

#import "MySQLAdaptor.h"
#import "MySQLChannel.h"

@class EOAttribute;

typedef enum {
    EOIntegerType,
    EODoubleType,
    EODecimalNumberType
} EONumberColumnValueType;

@interface MySQLColumn:NSObject
{
    EOAttribute *attribute;
    int fieldType;
}

+ (Class)columnClassForAttribute:(EOAttribute *)attr;
+ columnForAttribute:(EOAttribute *)attr;

- initWithAttribute:(EOAttribute*)attr type:(int)type;
- (EOAttribute *)attribute;

- (id)newValueForBytes:(const void *)bytes length:(int)length;

@end

@interface MySQLNumberColumn:MySQLColumn
{
    EONumberColumnValueType valueType;
}

- (id)newValueForBytes:(const void *)bytes length:(int)length;

@end

@interface MySQLStringColumn:MySQLColumn
{
    NSStringEncoding encoding;
}

- initWithAttribute:(EOAttribute *)attr type:(int)type;
- (id)newValueForBytes:(const void *)bytes length:(int)length;

@end

@interface MySQLDataColumn:MySQLColumn

- (id)newValueForBytes:(const void *)bytes length:(int)length;

@end

@interface MySQLDateColumn:MySQLColumn
{
}

- (id)newValueForBytes:(const void *)bytes length:(int)length;

@end
