/*
 * This file is subject to the MiscKit license, see http://www.misckit.org/
 * and search around for details. The bottom line is: you may do what you please
 * with this code, but you're on your own if you run into trouble...
 * Copyright (C) 1999,2000,2001 dmorin,anjo@mac.com
 * Portions of this code derived from the FlatFileAdaptor (C) Apple Computer
 */

#import "common.h"
#import "MySQLSQLExpression.h"
#import "MySQLSQLExpression.h"
#import "MySQLChannel.h"

@implementation MySQLSQLExpression

#if 0
not used any more... dec 7th
- (void)setFetchSpec:(EOFetchSpecification *)newFetchSpec;
{
    fetchSpec = newFetchSpec;
}

-(EOFetchSpecification *)fetchSpec;
{
    return fetchSpec;
}
#endif

+ (NSString *)formatValue:(id)value forAttribute:(EOAttribute *)attribute
{
    //if(debugEnabled) NSLog(@"formatValue:>%@< forAttribute:%@", [value class], attribute);
    if ( !value )
        return @"NULL";

    if ( value == [EONull null] )
        return @"NULL";

    if ( [value isKindOfClass:[NSData class]] )
    {
        char *buffer;
        NSString *encodedString;
        unsigned int length = [value length];

        buffer = NSZoneMalloc(NULL, length*2+1);
        if ( !buffer)
            [NSException raise:@"MySQLAdaptorExeption" format:@"Unable to allocate enought memory. Amount needed:%d", length*2+1];

        mysql_escape_string(buffer, [value bytes], [value length]);
        encodedString = [NSString stringWithFormat:@"'%s'",buffer];
        NSZoneFree(NULL, buffer);

        return encodedString;
    }
    if ( [value isKindOfClass:[NSString class]] )
    {
        char *buffer;
        NSString *encodedString;
        NSData *encodedData;
        unsigned int length;

        encodedData = [value dataUsingEncoding:[NSString defaultCStringEncoding] 
                          allowLossyConversion:YES];
        if ( !encodedData)
            [NSException raise:@"MySQLAdaptorExeption" format:@"Unable to encode string to default encoding.\nString: %@", value];

        length = [encodedData length];

        buffer = NSZoneMalloc(NULL, length*2+1);
        if ( !buffer)
            [NSException raise:@"MySQLAdaptorExeption" format:@"Unable to allocate enought memory. Amount needed:%d", length*2+1];

        mysql_escape_string(buffer, [encodedData bytes], length);
        encodedString = [NSString stringWithFormat:@"'%s'",buffer];
        NSZoneFree(NULL, buffer);

        return encodedString;
    }
    if ( [value isKindOfClass:[NSNumber class]] )
    {
        NSString *encodedString;

        encodedString = [value stringValue];

        return encodedString;
    }

    if ( [value isKindOfClass:[NSCalendarDate class]] )
    {
        NSString *encodedString;

        if([[attribute externalType] isEqualToString:@"TIMESTAMP"])
        {
            encodedString = [value descriptionWithCalendarFormat:@"'%Y%m%d%H%M%S'"];
        }
        else if([[attribute externalType] isEqualToString:@"TIME"])
        {
            encodedString = [value descriptionWithCalendarFormat:@"'%H:%M:%S'"];
        }
        else
        {
            encodedString = [value descriptionWithCalendarFormat:@"'%Y-%m-%d %H:%M:%S'"];
        }

        return encodedString;
    }

    return [super formatValue:value forAttribute:attribute];
}

- (NSString *)sqlStringForValue:(NSString *)valueString caseInsensitiveLikeKey:(NSString *)keyString
{
    // ak: mysql is case insensitive by default
    return [NSString stringWithFormat:@"%@ %@ %@", keyString, [self sqlStringForSelector:EOQualifierOperatorCaseInsensitiveLike value:valueString], valueString];
}

+ (NSArray *)primaryKeySupportStatementsForEntityGroup:(NSArray *)entityGroup
{
    return [NSArray array]; // The primaryKey support is generated on the fly
}

+ (NSArray *)dropPrimaryKeySupportStatementsForEntityGroup:(NSArray *)entityGroup
{
    return [NSArray array];
}

- (NSString *)assembleSelectStatementWithAttributes:(NSArray *)attributes
                                               lock:(BOOL)lock
                                          qualifier:(EOQualifier *)qualifier
                                         fetchOrder:(NSArray *)fetchOrder
                                       selectString:(NSString *)selectString
                                         columnList:(NSString *)columnList
                                          tableList:(NSString *)tableList
                                        whereClause:(NSString *)whereClause
                                         joinClause:(NSString *)joinClause
                                      orderByClause:(NSString *)orderByClause
                                         lockClause:(NSString *)lockClause
{
    NSMutableString *string;

    string = [NSMutableString stringWithFormat:@"%@ %@ %@ %@", selectString, columnList, @"FROM", tableList];

    if (lock) {
    }

    if (whereClause && [whereClause length])
        [string appendFormat:@" %@ %@", @"WHERE", whereClause];

    if (joinClause && [joinClause length]) {
        if (whereClause && [whereClause length])
            [string appendFormat:@" %@ %@", @"AND", joinClause];
        else
            [string appendFormat:@" %@ %@", @"WHERE", joinClause];
    }

    if (orderByClause && [orderByClause length])
        [string appendFormat:@" %@ %@", @"ORDER BY", orderByClause];

    return string;
}

@end
